/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modcreator;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/**
 *
 * @author Lucius Spiro
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String modname = "Spiros_test_mod";
        String name = "scutum";
        int volumen = 32;
        String crafter = "carpenter";
        String typ = "armor"; //weapons, armor, decoration, containers;
        String subtyp = "shield"; //only for armor: hat, shield, armor;
        ausführen(modname, name, typ, subtyp, volumen, crafter);
        // TODO code application logic here
    }

    public static void ausführen(String modname, String name, String typ, String subtyp, int volumen, String crafter) {
        try {
            File file = new File(modname + "/entities/" + typ + "/" + name + "/file.txt");
            File file2 = new File(modname + "/jobs/" + crafter + "/recipes/file.txt");
            file.getParentFile().mkdirs();
            file2.getParentFile().mkdirs();
            write_main(name, modname, typ, subtyp, volumen);
            write_ghost(name, modname, typ);
            write_iconic(name, modname, typ);
            write_recipe(name, modname, typ, crafter);
            write_manifest(name, modname, typ);
            write_recipes(name, modname, typ, crafter);
        } catch (Exception e) {
        }

    }

    private static void write_main(String name, String modname, String typ, String subtyp, int volumen) throws IOException {

        PrintWriter writer = new PrintWriter(modname + "/entities/" + typ + "/" + name + "/" + name + ".json", "UTF-8");
        if (typ.contentEquals("weapons")) {
            writer.println("{");
            writer.println("   \"mixins\": \"stonehearth:mixins:item_properties\",");
            writer.println("   \"type\": \"entity\",");
            writer.println("   \"components\": {");
            writer.println("      \"unit_info\": {");
            writer.println("         \"display_name\": \"i18n(" + name + ")\",");
            writer.println("         \"description\": \"i18n(" + name + ")\",");
            writer.println("         \"icon\": \"file(" + name + ".png)\"");
            writer.println("      },");
            writer.println("      \"item\": {");
            writer.println("         \"category\": \"weapons\"");
            writer.println("      },");
            writer.println("      \"stonehearth:material\": {");
            writer.println("         \"tags\": \"long melee_weapon crafted\"");
            writer.println("      },");
            writer.println("      \"model_variants\": {");
            writer.println("         \"default\": {");
            writer.println("            \"models\": [");
            writer.println("               \"file(" + name + "_equipped.qb)\"");
            writer.println("            ]");
            writer.println("         }");
            writer.println("      },");
            writer.println("      \"stonehearth:entity_forms\": {");
            writer.println("         \"iconic_form\": \"file(" + name + "_iconic.json)\"");
            writer.println("      },");
            writer.println("      \"stonehearth:equipment_piece\": {");
            writer.println("         \"slot\": \"mainhand\",");
            writer.println("         \"render_type\": \"attach_to_bone\",");
            writer.println("         \"postures\": [");
            writer.println("            \"stonehearth:combat\",");
            writer.println("            \"stonehearth:patrol\"");
            writer.println("         ],");
            writer.println("         \"ilevel\": 16,");
            writer.println("         \"roles\": \"combat\",");
            writer.println("         \"equip_effect\": \"/stonehearth/data/effects/weapon_level_up\"");
            writer.println("      }");
            writer.println("   },");
            writer.println("   \"entity_data\": {");
            writer.println("      \"stonehearth:combat:weapon_data\": {");
            writer.println("         \"base_damage\": 24,");
            writer.println("         \"reach\": 1.8");
            writer.println("      },");
            writer.println("      \"stonehearth:combat:melee_attacks\": [");
            writer.println("         {");
            writer.println("            \"name\": \"combat_1h_backhand\",");
            writer.println("            \"active_frame\": 17,");
            writer.println("            \"cooldown\": 0,");
            writer.println("            \"priority\": 0");
            writer.println("         },");
            writer.println("         {");
            writer.println("            \"name\": \"combat_1h_forehand\",");
            writer.println("            \"active_frame\": 16,");
            writer.println("            \"cooldown\": 0,");
            writer.println("            \"priority\": 0");
            writer.println("         }");
            writer.println("      ],");
            writer.println("      \"stonehearth:combat:melee_defenses\": [");
            writer.println("         {");
            writer.println("            \"name\": \"combat_1h_parry\",");
            writer.println("            \"active_frame\": 4,");
            writer.println("            \"cooldown\": 8000,");
            writer.println("            \"priority\": 0");
            writer.println("         }");
            writer.println("      ],");
            writer.println("      \"stonehearth:net_worth\": {");
            writer.println("         \"value_in_gold\": 150,");
            writer.println("         \"rarity\": \"common\",");
            writer.println("         \"shop_info\": {");
            writer.println("            \"buyable\": true,");
            writer.println("            \"sellable\": true,");
            writer.println("            \"shopkeeper_level\": 1,");
            writer.println("            \"shopkeeper_type\": \"caravan\"");
            writer.println("         }");
            writer.println("      }");
            writer.println("   }");
            writer.println("}");
        } else if (typ.contentEquals("armor")) {
            writer.println("{");
            writer.println("   \"mixins\": \"stonehearth:mixins:item_properties\",");
            writer.println("   \"type\": \"entity\",");
            writer.println("   \"components\": {");
            writer.println("      \"unit_info\": {");
            writer.println("         \"display_name\": \"i18n(" + name + ")\",");
            writer.println("         \"description\": \"i18n(" + name + ")\",");
            writer.println("         \"icon\": \"file(" + name + ".png)\"");
            writer.println("      },");
            writer.println("      \"item\": {");
            writer.println("         \"category\": \"armor\"");
            writer.println("      },");
            writer.println("      \"stonehearth:material\": {");
            writer.println("         \"tags\": \"bronze armor heavy_armor\"");
            writer.println("      },");

            if (!subtyp.contentEquals("shield")) {
                writer.println("      \"model_variants\": {");
                writer.println("         \"default\": {");
                writer.println("            \"layer\": \"" + subtyp + "\",");
                writer.println("            \"transparent\": \"false\",");
                writer.println("            \"models\": [");
                writer.println("               \"file(" + name + ".qb)\"");
                writer.println("            ]");
                writer.println("         },");
                writer.println("         \"female\": {");
                writer.println("            \"layer\": \"" + subtyp + "\",");
                writer.println("            \"transparent\": \"false\",");
                writer.println("            \"models\": [");
                writer.println("               \"file(" + name + "_female.qb)\"");
                writer.println("            ]");
                writer.println("         }");
                writer.println("      },");
            } else {
                writer.println("\"model_variants\": {");
                writer.println("         \"default\": {");
                writer.println("            \"models\": [");
                writer.println("               \"file(scutum.qb)\"");
                writer.println("            ]");
                writer.println("         }");
                writer.println("      },");
            }
            if (!typ.contentEquals("shield")) {
                writer.println("      \"stonehearth:entity_forms\": {");
                writer.println("         \"iconic_form\": \"file(" + name + "_iconic.json)\"");
                writer.println("      },");
                writer.println("      \"stonehearth:equipment_piece\": {");
                if (subtyp.contentEquals("armor")) {
                    writer.println("         \"slot\": \"torso\",");
                } else if (subtyp.contentEquals("hat")) {
                    writer.println("         \"slot\": \"helmet\",");
                }

                writer.println("         \"render_type\": \"merge_with_model\",");
                writer.println("         \"ilevel\": 4,");
                writer.println("         \"roles\": \"combat\",");
                writer.println("         \"equip_effect\": \"/stonehearth/data/effects/level_up\"");
                writer.println("      }");

            } else {
                writer.println("\"stonehearth:equipment_piece\": {");
                writer.println("         \"slot\": \"offhand\",");
                writer.println("         \"render_type\": \"attach_to_bone\",");
                writer.println("         \"postures\": [");
                writer.println("            \"stonehearth:combat\",");
                writer.println("            \"stonehearth:patrol\",");
                writer.println("            \"stonehearth:have_shield\"");
                writer.println("         ],");
                writer.println("         \"ilevel\": 6,");
                writer.println("         \"roles\": \"combat\",");
                writer.println("         \"equip_effect\": \"/stonehearth/data/effects/weapon_level_up\"");
                writer.println("      }");
            }
            writer.println("   },");
            writer.println("   \"entity_data\": {");
            writer.println("      \"stonehearth:combat:armor_data\": {");
            writer.println("         \"base_damage_reduction\": 7");
            writer.println("      },");
            if (subtyp.contentEquals("shield")) {
                writer.println("\"stonehearth:combat:melee_defenses\": [");
                writer.println("         {");
                writer.println("            \"name\": \"combat_1h_shield_block\",");
                writer.println("            \"active_frame\": 4,");
                writer.println("            \"cooldown\": 1000,");
                writer.println("            \"priority\": 0");
                writer.println("         }");
                writer.println("      ],");
            }
            writer.println("      \"stonehearth:net_worth\": {");
            writer.println("         \"value_in_gold\": 105,");
            writer.println("         \"rarity\": \"common\",");
            writer.println("         \"shop_info\": {");
            writer.println("            \"buyable\": true,");
            writer.println("            \"sellable\": true,");
            writer.println("            \"shopkeeper_level\": 1,");
            writer.println("            \"shopkeeper_type\": \"caravan\"");
            writer.println("         }");
            writer.println("      }");
            writer.println("   }");
            writer.println("}");
        } else if (typ.contentEquals("containers") || typ.contentEquals("decoration")) {
            writer.println("{");
            writer.println("   \"type\": \"entity\",");
            writer.println("   \"mixins\": \"file(" + name + "_ghost.json)\",");
            writer.println("   \"components\": {");
            if (typ.contentEquals("containers")) {
                writer.println("      \"stonehearth:storage\": {");
                writer.println("         \"type\": \"crate\",");
                writer.println("         \"capacity\": " + volumen + "");
                writer.println("      },");
            }
            writer.println("      \"stonehearth:entity_forms\": {");
            writer.println("         \"iconic_form\": \"file(" + name + "_iconic.json)\",");
            writer.println("         \"ghost_form\": \"file(" + name + "_ghost.json)\",");
            writer.println("         \"placeable_on_ground\": true");
            writer.println("      },");
            writer.println("      \"destination\": {");
            writer.println("         \"region\": [");
            writer.println("            {");
            writer.println("               \"min\": {");
            writer.println("                  \"x\": -1,");
            writer.println("                  \"y\": 0,");
            writer.println("                  \"z\": -1");
            writer.println("               },");
            writer.println("               \"max\": {");
            writer.println("                  \"x\": 1,");
            writer.println("                  \"y\": 3,");
            writer.println("                  \"z\": 1");
            writer.println("               }");
            writer.println("            }");
            writer.println("         ]");
            writer.println("      },");
            writer.println("      \"region_collision_shape\": {");
            writer.println("         \"region\": [");
            writer.println("            {");
            writer.println("               \"min\": {");
            writer.println("                  \"x\": -1,");
            writer.println("                  \"y\": 0,");
            writer.println("                  \"z\": -1");
            writer.println("               },");
            writer.println("               \"max\": {");
            writer.println("                  \"x\": 1,");
            writer.println("                  \"y\": 3,");
            writer.println("                  \"z\": 1");
            writer.println("               }");
            writer.println("            }");
            writer.println("         ]");
            writer.println("      }");
            writer.println("   },");
            writer.println("   \"entity_data\": {");
            writer.println("      \"stonehearth:town_patrol\": {");
            writer.println("         \"auto_patrol\": true,");
            writer.println("         \"patrol_pattern\": \"perimeter\"");
            writer.println("      },");
            writer.println("      \"stonehearth:net_worth\": {");
            writer.println("         \"value_in_gold\": 14,");
            writer.println("         \"rarity\": \"common\",");
            writer.println("         \"shop_info\": {");
            writer.println("            \"buyable\": false,");
            writer.println("            \"sellable\": true,");
            writer.println("            \"shopkeeper_level\": 1,");
            writer.println("            \"shopkeeper_type\": \"caravan\"");
            writer.println("         }");
            writer.println("      }");
            writer.println("   }");
            writer.println("}");
        }

        writer.close();
    }

    private static void write_ghost(String name, String modname, String typ) throws IOException {
        if (!typ.contentEquals("weapons") && !typ.contentEquals("armor")) {
            
            PrintWriter writer = new PrintWriter(modname + "/entities/" + typ + "/" + name + "/" + name + "_ghost.json", "UTF-8");
            writer.println("{");
            writer.println("   \"components\": {");
            writer.println("      \"model_variants\": {");
            writer.println("         \"default\": {");
            writer.println("            \"models\": [");
            writer.println("               \"file(" + name + ".qb)\"");
            writer.println("            ]");
            writer.println("         }");
            writer.println("      },");
            writer.println("      \"render_info\": {");
            writer.println("         \"scale\": 0.1");
            writer.println("      },");
            writer.println("      \"unit_info\": {");
            writer.println("         \"display_name\": \"i18n(" + modname + ":entities." + typ + "." + name + "." + name + "_ghost.display_name)\",");
            writer.println("         \"description\": \"i18n(" + modname + ":entities." + typ + "." + name + "." + name + "_ghost.description)\",");
            writer.println("         \"icon\": \"file(" + name + ".png)\"");
            writer.println("      },");
            writer.println("      \"stonehearth:material\": {");
            writer.println("         \"tags\": \"wood furniture crafted\"");
            writer.println("      },");
            writer.println("      \"mob\": {");
            writer.println("         \"model_origin\": { \"x\": 0, \"y\": 0, \"z\": 0 },");
            writer.println("         \"region_origin\": { \"x\": 0, \"y\": 0, \"z\": 0 },");
            writer.println("         \"align_to_grid\": [");
            writer.println("            \"x\",");
            writer.println("            \"z\"");
            writer.println("         ],");
            writer.println("         \"allow_vertical_adjacent\": true");
            writer.println("      }");
            writer.println("   }");
            writer.println("}");

            writer.close();
        }
    }

    private static void write_iconic(String name, String modname, String typ) throws IOException {


        PrintWriter writer = new PrintWriter(modname + "/entities/" + typ + "/" + name + "/" + name + "_iconic.json", "UTF-8");
        if (typ.contentEquals("weapons") || typ.contentEquals("armor")) {
            writer.println("{");
            writer.println("   \"mixins\": \"stonehearth:mixins:item_properties\",");
            writer.println("   \"type\": \"entity\",");
            writer.println("   \"components\": {");
            writer.println("      \"unit_info\": {");
            writer.println("         \"display_name\": \"i18n(" + name + ")\",");
            writer.println("         \"description\": \"i18n(" + name + ")\",");
            writer.println("         \"icon\": \"file(" + name + ".png)\"");
            writer.println("      },");
            writer.println("      \"item\": {");
            writer.println("         \"category\": \"" + typ + "\"");
            writer.println("      },");
            writer.println("      \"stonehearth:material\": {");
            writer.println("         \"tags\": \"long melee_weapon crafted\"");
            writer.println("      },");
            writer.println("      \"model_variants\": {");
            writer.println("         \"default\": {");
            writer.println("            \"models\": [");
            if (typ.contentEquals("weapons")) {
                writer.println("               \"file(" + name + ".qb)\"");
            } else {
                writer.println("               \"file(" + name + "_iconic.qb)\"");
            }
            writer.println("            ]");
            writer.println("         }");
            writer.println("      },");
            if (typ.contentEquals("armor")) {
                writer.println("      \"mob\": {");
                writer.println("         \"model_origin\": { \"x\": -0.05, \"y\": 0, \"z\": 0.05 }");
                writer.println("      }");
            }
            writer.println("   }");
            writer.println("}");
        } else {
            writer.println("{");
            writer.println("   \"mixins\": \"stonehearth:mixins:item_properties\",");
            writer.println("   \"components\": {");
            writer.println("      \"item\" : {");
            writer.println("         \"category\" : \"furniture\"");
            writer.println("      },");
            writer.println("      \"model_variants\": {");
            writer.println("         \"default\": {");
            writer.println("            \"models\": [");
            writer.println("               \"file(" + name + "_iconic.qb)\"");
            writer.println("            ]");
            writer.println("         }");
            writer.println("      },");
            writer.println("      \"mob\" : {");
            writer.println("         \"model_origin\" : { \"x\": 0 , \"y\": 0, \"z\": 0 }");
            writer.println("      }");
            writer.println("   }");
            writer.println("}");
        }
        writer.close();

    }

    private static void write_recipe(String name, String modname, String typ, String crafter) throws IOException {


        PrintWriter writer = new PrintWriter(modname + "/jobs/" + crafter + "/recipes/" + name + "_recipe.json", "UTF-8");
        writer.println("{");
        writer.println("   \"type\": \"recipe\",");
        writer.println("   \"work_units\": 3,");
        writer.println("   \"recipe_name\": \"i18n(" + name + ")\",");
        writer.println("   \"description\": \"i18n()\",");
        writer.println("   \"flavor\": \"i18n()\",");
        writer.println("   \"portrait\": \"/" + modname + "/entities/" + typ + "/" + name + "/" + name + ".png\",");
        writer.println("   \"workshop\"    : \"stonehearth:" + crafter + ":workbench\", ");
        writer.println("   \"level_requirement\": 0,");
        writer.println("   \"ingredients\": [");
        writer.println("      {");
        writer.println("         \"material\": \"wood resource\",");
        writer.println("         \"count\": 1");
        writer.println("      }");
        writer.println("   ],");
        writer.println("   \"produces\": [");
        writer.println("      {");
        writer.println("         \"item\": \"" + modname + ":" + name + "\"");
        writer.println("      }");
        writer.println("   ]");
        writer.println("}");
        writer.close();

    }

    private static void write_manifest(String name, String modname, String typ) throws IOException {

        try {
            FileReader fr = new FileReader(modname + "/manifest.json");
            BufferedReader br = new BufferedReader(fr);
            String test[] = new String[1000];
            boolean flag = false;

            int i;
            int z = 0;
            for (i = 0; br.ready(); i++) {

                test[i] = br.readLine();
                if (test[i].endsWith("\"aliases\" : {") && !flag) {

                    test[i + 1] = "      \"" + name + "\" : \"file(entities/" + typ + "/" + name + ")\",";
                    flag = true;

                    i++;
                }
            }
            br.close();
            PrintWriter writer = new PrintWriter(modname + "/manifest.json", "UTF-8");
            for (int j = 0; j != i + z; j++) {

                writer.println(test[j]);
            }


            writer.close();
        } catch (Exception e) {
            PrintWriter writer = new PrintWriter(modname + "/manifest.json", "UTF-8");
            writer.println("{");
            writer.println("");
            writer.println("   \"info\" : {");
            writer.println("");
            writer.println("       \"name\" : \"" + modname + "\",");
            writer.println(" ");
            writer.println("      \"version\" : 2");
            writer.println("");
            writer.println("   },");
            writer.println("");
            writer.println("   \"default_locale\": \"en\",");
            writer.println("");
            writer.println("   \"aliases\" : {");
            writer.println("      ");
            writer.println("      \"" + name + "\" : \"file(entities/" + typ + "/" + name + ")\"");
            writer.println("");
            writer.println("   },");
            writer.println(" ");
            writer.println("   \"mixintos\" : {");
            writer.println("");
            writer.println("   },");
            writer.println("   \"overrides\": {");
            writer.println("");
            writer.println("   }");
            writer.println("    ");
            writer.println("}");
            writer.close();
        }
    }

    private static void write_recipes(String name, String modname, String typ, String crafter) throws IOException {

        try {
            FileReader fr = new FileReader(modname + "/jobs/" + crafter + "/recipes/recipes.json");
            BufferedReader br = new BufferedReader(fr);
            String test[] = new String[1000];
            boolean flag = false;

            int i;
            int z = 0;
            for (i = 0; br.ready(); i++) {

                test[i] = br.readLine();
                if (test[i].endsWith("\"recipes\" : {") && !flag) {

                    test[i + 1] = "            \"" + name + "\" : {";
                    test[i + 2] = "               \"recipe\" : \"file(" + name + "_recipe.json)\"";
                    test[i + 3] = "            },";
                    flag = true;

                    i += 3;
                }
            }
            br.close();
            PrintWriter writer = new PrintWriter(modname + "/jobs/" + crafter + "/recipes/recipes.json");
            for (int j = 0; j != i + z; j++) {

                writer.println(test[j]);
            }


            writer.close();
        } catch (Exception e) {

            PrintWriter writer = new PrintWriter(modname + "/jobs/" + crafter + "/recipes/recipes.json", "UTF-8");
            writer.println("{");
            writer.println("   \"craftable_recipes\" : {");
            writer.println("      \"building_parts\" : {");
            writer.println("         \"ordinal\" : 4,");
            writer.println("         \"name\" : \"i18n(Spiros mod generator)\",");
            writer.println("         \"recipes\" : {");
            writer.println("            \"" + name + "\" : {");
            writer.println("               \"recipe\" : \"file(" + name + "_recipe.json)\"");
            writer.println("            }");
            writer.println("         }");
            writer.println("      }");
            writer.println("   }");
            writer.println("}");

            writer.close();
        }
    }
}
